"""Common filenames and locations for topographic data, meshes and outputs.
"""


from os import sep
from os import environ
from os.path import expanduser
import sys

#Making assumptions about the location of scenario data
# Assumes the INUNDATIONHOME environ variable exists

scenario_dir_name = 'momentum_sink_2005'
basename = 'buildings'

if sys.platform == 'win32':
    home = environ["INUNDATIONHOME"]     #Sandpit's parent dir
else:    
    home = expanduser('~')


#Derive subdirectories and filenames
meshdir = home+sep+scenario_dir_name+sep+'meshes'+sep
outputdir = home+sep+scenario_dir_name+sep+'output'+sep
building_dir = home+sep+scenario_dir_name+sep+'output'+sep
friction_dir = home+sep+scenario_dir_name+sep+'output'+sep
meshname = meshdir + basename + '.tsh'
outputname = outputdir + basename  + '.sww' #Used by post processing

#-------------------------------------------------------------
if __name__ == "__main__":
    print "mesh_elevname",mesh_elevname
    update_names(999)
    print "mesh_elevname",mesh_elevname 
